package com.bzd.web.controller.hygl.jf;

import com.bzd.common.annotation.Log;
import com.bzd.common.config.dao.PageData;
import com.bzd.common.core.controller.BaseController;
import com.bzd.common.core.domain.AjaxResult;
import com.bzd.common.core.domain.entity.SysUser;
import com.bzd.common.core.page.TableDataInfo;
import com.bzd.common.enums.BusinessType;
import com.bzd.system.service.PharmaceuticalService;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.*;
import com.bzd.system.service.hygl.jf.SHyglJfglOrderinfoService;

import java.util.List;

/**
*
* 兑换记录表 前端控制器Controller
* @author LiXiangFei
* @since 2024-10-15
*/
@Controller
@RequestMapping(value = "hygl/shygljfglorderinfo")
public class SHyglJfglOrderinfoController extends BaseController {

    // 页面跳转前缀
    private String prefix = "hygl/jf";

    @Autowired
    private SHyglJfglOrderinfoService sHyglJfglOrderinfoService;

    /**
    * 兑换记录表 新增页面跳转
    *
    * @return
    */
    @RequiresPermissions("hygl:jf:view")
    @GetMapping("/sHyglJfglOrderinfoAdd")
    public String add() {
        return prefix + "/SHyglJfglOrderinfoAdd";
    }

    /**
    * 兑换记录表 新增
    *
    * @return
    */
    @Log(title = "兑换记录表新增", businessType = BusinessType.INSERT)
    @PostMapping("/sHyglJfglOrderinfoAdd")
    @ResponseBody
    public AjaxResult addSave() throws Exception {
        PageData pd = this.getPageData();
        try {
            Integer result = sHyglJfglOrderinfoService.addSHyglJfglOrderinfo(pd);
            if (result == 1) {
                return AjaxResult.success("新增成功");
            } else {
                logger.error("Failed to update 表skccrkckreceiptinfo with ID: {}", pd.get("id"));
                return AjaxResult.error("新增失败");
            }
        } catch (Exception e) {
            logger.error("Error occurred while updating 表skccrkckreceiptinfo with ID: {}, Exception: {}", pd.get("id"), e.getMessage(), e);
            return AjaxResult.error("系统异常：" + e.getMessage());
        }
    }

    /**
    * 兑换记录表 查询页面跳转
    *
    * @return
    */
    @RequiresPermissions("hygl:jf:view")
    @GetMapping("/sHyglJfglOrderinfoView")
    public String shygljfglorderinfoListView() {
        return prefix + "/SHyglJfglOrderinfoList";
    }

    /**
    * 兑换记录表 数据查询
    *
    * @return
    * @throws Exception
    */
    @RequiresPermissions("hygl:jf:sHyglJfglOrderinfoList")
    @PostMapping("/sHyglJfglOrderinfoList")
    @ResponseBody
    public TableDataInfo shygljfglorderinfoList() throws Exception {
    PageData pd = this.getPageData();
    startPage();
    List<PageData> pageData = sHyglJfglOrderinfoService.findSHyglJfglOrderinfoList(pd);
        return getDataTable(pageData);
    }

    /**
    * 兑换记录表 数据删除 根据id
    *
    * @return
    * @throws Exception
    */
    @RequiresPermissions("hygl:jf:remove")
    @Log(title = "兑换记录表删除", businessType = BusinessType.DELETE)
    @PostMapping("/sHyglJfglOrderinfoRemove")
    @ResponseBody
    public AjaxResult shygljfglorderinfoRemove() throws Exception {
        PageData pd = this.getPageData();
        Integer integer = sHyglJfglOrderinfoService.SHyglJfglOrderinfoRemove(pd);
        return toAjax(integer);
    }
    /**
     * 兑换记录表 数据修改
     *
     * @return
     * @throws Exception
     */
    @RequiresPermissions("hygl:jf:edit")
    @GetMapping("/checkProduct")
    public String checkProduct(ModelMap mmap) throws Exception {
        PageData pd = this.getPageData();
        SysUser user = getSysUser();
        pd.put("user", user.getUserId());
        mmap.putAll(pd);
        return prefix+ "/SHyglJfglOrderinfoHxSp";
    }
    /**
    * 兑换记录表 数据修改
    *
    * @return
    * @throws Exception
    */
    @RequiresPermissions("hygl:jf:edit")
    @GetMapping("/sHyglJfglOrderinfoEdit/{id}")
    public String shygljfglorderinfoView(@PathVariable("id") Long id, ModelMap mmap) throws Exception {
        PageData pd = this.getPageData();
        pd.put("id", id);
        PageData pageData = sHyglJfglOrderinfoService.findSHyglJfglOrderinfoList(pd).get(0);
        mmap.putAll(pageData);
        if(null!=pd.getString("status")){
            return prefix+ "/shygljfglorderinfoPageEdit";
        }
        return prefix+ "/shygljfglorderinfoEdit";
    }

    /**
    * 兑换记录表保存修改的数据
    */
    @RequiresPermissions("hygl:jf:edit")
    @Log(title = "兑换记录表修改", businessType = BusinessType.UPDATE)
    @PostMapping("/sHyglJfglOrderinfoEdit")
    @ResponseBody
    public AjaxResult shygljfglorderinfoEditSave() throws Exception {
        PageData pd = this.getPageData();
        pd.put("up", "up");
        try {
            Integer updateResult = sHyglJfglOrderinfoService.updateSHyglJfglOrderinfo(pd);
            if (updateResult == 1) {
                // 成功更新
                return AjaxResult.success("修改成功");
            } else {
                // 更新失败
                logger.error("Failed to update 表shygljfglorderinfo with ID: {}", pd.get("id"));
                return AjaxResult.error("修改失败");
            }
        } catch (Exception e) {
            // 异常处理
            logger.error("Error occurred while updating 表shygljfglorderinfo with ID: {}, Exception: {}", pd.get("id"), e.getMessage(), e);
            return AjaxResult.error("系统异常：" + e.getMessage());
        }
    }
}
